diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -3077,58 +5267,122 @@
     }
     */
 
-    soundTicks -= clockTicks;
+    clockTicks = 0;
 
-    while(soundTicks < 0) {
-      soundTicks += SOUND_CLOCK_TICKS;
+    if (gbIntBreak == 1)
+    {
+      gbIntBreak = 0;
+      if ((register_IE & register_IF & gbInterruptLaunched & 0x3) && 
+         ((IFF & 0x81) == 1) && (!gbInterruptWait) && (execute))
+      {
+        gbIntBreak = 2;
+        PC.W = oldPCW;
+        execute = false;
+        gbOldClockTicks = 0;
+      }
+      if (gbOldClockTicks)
+      {
+        clockTicks = gbOldClockTicks;
+        gbOldClockTicks = 0;
+        goto gbRedoLoop;
+      }
+    }
 
-      gbSoundTick();
+    // Executes the opcode(s), and apply the instruction's remaining clockTicks (if any).
+    if (execute)
+    {
+      switch(opcode1) {
+      case 0xCB:
+        // extended opcode
+        switch(opcode2) {
+#include "gbCodesCB.h"
+        }
+        break;
+#include "gbCodes.h"    
+      }
+      execute = false;
+
+      if (clockTicks)
+      {
+        gbDmaTicks += clockTicks;
+        clockTicks = 0;
+      }
     }
-    
-    register_IF = gbInterrupt;
 
-    if(IFF & 0x20) {
-      IFF &= 0xdf;
-      IFF |= 0x01;
-      gbInterruptWait = 0;
-    } else if(gbInterrupt) {
-      if(gbInterruptWait == 0) {
-        //        gbInterruptWait = 0;
-
-        if(IFF & 0x01) {
-          if((gbInterrupt & 1) && (register_IE & 1)) {
-            gbVblank_interrupt();
-            continue;
-          }
-          
-          if((gbInterrupt & 2) && (register_IE & 2)) {
-            gbLcd_interrupt();
-            continue;
-          }
-          
-          if((gbInterrupt & 4) && (register_IE & 4)) {
-            gbTimer_interrupt();
-            continue;
-          }
-          
-          if((gbInterrupt & 8) && (register_IE & 8)) {
-            gbSerial_interrupt();
-            continue;
-          }
+    if (gbDmaTicks)
+    {
+      clockTicks = gbGetNextEvent(gbDmaTicks);
 
-          if((gbInterrupt & 16) && (register_IE & 16)) {
-            gbJoypad_interrupt();
-            continue;
-          }
+      if (clockTicks<=gbDmaTicks)
+        gbDmaTicks -= clockTicks;
+      else
+      {
+        clockTicks = gbDmaTicks;
+        gbDmaTicks = 0;
+      }
+
+      goto gbRedoLoop;
+    }
+
+
+    // Remove the 'if an IE is pending' flag if IE has finished being executed.
+    if ((IFF & 0x40) && !(IFF & 0x30))
+      IFF &= 0x81;
+
+
+
+    if ((register_IE & register_IF & 0x1f) && (IFF & 0x81) && (!gbInterruptWait))
+    {        
+
+      if (IFF & 1)
+      {
+        // Add 5 ticks for the interrupt execution time
+        gbDmaTicks +=  5;
+
+        if (gbIntBreak == 2)
+        {
+          gbDmaTicks--;
+          gbIntBreak = 0;
         }
-      } else {
-        gbInterruptWait -= clockTicks;
-        if(gbInterruptWait < 0)
-          gbInterruptWait = 0;
+
+
+        if(register_IF & register_IE & 1)
+          gbVblank_interrupt();
+        else if(register_IF & register_IE & 2)
+          gbLcd_interrupt();
+        else if(register_IF & register_IE & 4)
+          gbTimer_interrupt();
+        else if(register_IF & register_IE & 8)
+          gbSerial_interrupt();
+        else if(register_IF & register_IE & 16)
+          gbJoypad_interrupt();
+      }
+
+      IFF &= ~0x81;
+    }
+
+    if (IFF & 0x08)
+      IFF &=~0x79;
+    
+    // Used to apply the interrupt's execution time.
+    if (gbDmaTicks)
+    {
+      clockTicks = gbGetNextEvent(gbDmaTicks);
+
+      if (clockTicks<=gbDmaTicks)
+        gbDmaTicks -= clockTicks;
+      else
+      {
+        clockTicks = gbDmaTicks;
+        gbDmaTicks = 0;
       }
+      goto gbRedoLoop;
     }
 
-    if(ticksToStop <= 0) {
+
+    gbBlackScreen = false;
+
+    if((ticksToStop <= 0)) {
       if(!(register_LCDC & 0x80)) {
         if(systemReadJoypads()) {
           // read joystick
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.h ./src/gb/GB.h
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.h	2004-05-13 23:11:09 +0900
+++ ./src/gb/GB.h	2006-06-06 23:25:43 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -38,11 +38,15 @@
 
 extern bool gbLoadRom(const char *);
 extern void gbEmulate(int);
+extern void gbWriteMemory(register u16, register u8);
+extern void gbDrawLine();
 extern bool gbIsGameboyRom(const char *);
 extern void gbSoundReset();
 extern void gbSoundSetQuality(int);
+extern void gbGetHardwareType();
 extern void gbReset();
 extern void gbCleanUp();
+extern void gbCPUInit(const char *,bool);
 extern bool gbWriteBatteryFile(const char *);
 extern bool gbWriteBatteryFile(const char *, bool);
 extern bool gbReadBatteryFile(const char *);
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbCheats.cpp ./src/gb/gbCheats.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/gbCheats.cpp	2004-05-13 23:40:33 +0900
+++ ./src/gb/gbCheats.cpp	2006-06-06 23:25:43 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -27,9 +27,11 @@
 
 #include "gbCheats.h"
 #include "gbGlobals.h"
+#include "GB.h"
 
 gbCheat gbCheatList[100];
 int gbCheatNumber = 0;
+int gbNextCheat = 0;
 bool gbCheatMap[0x10000];
 
 extern bool cheatsEnabled;
@@ -50,7 +52,7 @@
 void gbCheatsSaveGame(gzFile gzFile)
 {
   utilWriteInt(gzFile, gbCheatNumber);
-  if(gbCheatNumber)
+  if(gbCheatNumber>0)
     utilGzWrite(gzFile, &gbCheatList[0], sizeof(gbCheat)*gbCheatNumber);
 }
 
@@ -81,7 +83,7 @@
   } else {
     gbCheatNumber = utilReadInt(gzFile);
 
-    if(gbCheatNumber) {
+    if(gbCheatNumber>0) {
       utilGzRead(gzFile, &gbCheatList[0], sizeof(gbCheat)*gbCheatNumber);
     }
   }
@@ -163,7 +165,7 @@
 
 bool gbVerifyGsCode(const char *code)
 {
-  int len = strlen(code);
+  size_t len = strlen(code);
 
   if(len == 0)
     return true;
@@ -180,10 +182,6 @@
     GBCHEAT_HEX_VALUE(code[4]) << 4 |
     GBCHEAT_HEX_VALUE(code[5]);
 
-  if(address < 0xa000 ||
-     address > 0xdfff)
-    return false;
-
   return true;
 }
 
@@ -220,15 +218,23 @@
   gbCheatList[i].compare = 0;
 
   gbCheatList[i].enabled = true;
-  
-  gbCheatMap[gbCheatList[i].address] = true;
-  
+
+  int gsCode = gbCheatList[i].code;
+
+  if ((gsCode !=1) && ((gsCode & 0xF0) !=0x80) && ((gsCode & 0xF0) !=0x90) &&
+      ((gsCode & 0xF0) !=0xA0) && ((gsCode) !=0xF0) && ((gsCode) !=0xF1))
+    systemMessage(MSG_WRONG_GAMESHARK_CODE,
+                  N_("Wrong GameShark code type : %s"), code);
+  else if (((gsCode & 0xF0) ==0xA0) || ((gsCode) ==0xF0) || ((gsCode) ==0xF1))
+    systemMessage(MSG_UNSUPPORTED_GAMESHARK_CODE,
+                  N_("Unsupported GameShark code type : %s"), code);
+
   gbCheatNumber++;
 }
 
 bool gbVerifyGgCode(const char *code)
 {
-  int len = strlen(code);
+  size_t len = strlen(code);
 
   if(len != 11 &&
      len != 7 &&
@@ -313,12 +319,12 @@
   
   int i = gbCheatNumber;
 
-  int len = strlen(code);
+  size_t len = strlen(code);
   
   strcpy(gbCheatList[i].cheatCode, code);
   strcpy(gbCheatList[i].cheatDesc, desc);
 
-  gbCheatList[i].code = 1;
+  gbCheatList[i].code = 0x101;
   gbCheatList[i].value = (GBCHEAT_HEX_VALUE(code[0]) << 4) +
     GBCHEAT_HEX_VALUE(code[1]);
   
@@ -338,9 +344,12 @@
     compare ^= 0x45;
 
     gbCheatList[i].compare = compare;
-    gbCheatList[i].code = 0;
+    //gbCheatList[i].code = 0;
+    gbCheatList[i].code = 0x100; // fix for compare value
+
   }
 
+
   gbCheatList[i].enabled = true;
   
   gbCheatMap[gbCheatList[i].address] = true;
@@ -425,6 +434,7 @@
   return true;
 }
 
+// Used to emulated GG codes
 u8 gbCheatRead(u16 address)
 {
   if(!cheatsEnabled)
@@ -437,26 +447,72 @@
         if(gbMemoryMap[address>>12][address&0xFFF] == gbCheatList[i].compare)
           return gbCheatList[i].value;
         break;
-      case 0x00:
-      case 0x01:
-      case 0x80:
-        return gbCheatList[i].value;
-      case 0x90:
-      case 0x91:
-      case 0x92:
-      case 0x93:
-      case 0x94:
-      case 0x95:
-      case 0x96:
-      case 0x97:
-        if(address >= 0xd000 && address < 0xe000) {
-          if(((gbMemoryMap[0x0d] - gbWram)/0x1000) ==
-             (gbCheatList[i].code - 0x90))
-            return gbCheatList[i].value;
-        } else
+      case 0x101: // GameGenie 6 digits code support
           return gbCheatList[i].value;
+        break;
       }
     }
   }
   return gbMemoryMap[address>>12][address&0xFFF];
 }
+
+
+// Used to emulate GS codes.
+void gbCheatWrite(bool reboot)
+{
+  if(cheatsEnabled)
+  {
+    u16 address = 0;
+
+    if (gbNextCheat >= gbCheatNumber)
+      gbNextCheat = 0;
+
+    for(int i = gbNextCheat; i < gbCheatNumber; i++) {
+      if(gbCheatList[i].enabled) {
+        address = gbCheatList[i].address;
+        if ((!reboot) && (address >= 0x8000) && !((address>=0xA000) && (address<0xC000)))
+        { // These codes are executed one per one, at each Vblank
+          switch(gbCheatList[i].code) {
+            case 0x01:
+              gbWriteMemory(address, gbCheatList[i].value);
+              gbNextCheat = i+1;
+              return;
+            case 0x90:
+            case 0x91:
+            case 0x92:
+            case 0x93:
+            case 0x94:
+            case 0x95:
+            case 0x96:
+            case 0x97:
+            case 0x98:
+            case 0x99:
+            case 0x9A:
+            case 0x9B:
+            case 0x9C:
+            case 0x9D:
+            case 0x9E:
+            case 0x9F:
+              int oldbank = gbMemory[0xff70];
+              gbWriteMemory(0xff70, gbCheatList[i].code & 0xf);
+              gbWriteMemory(address, gbCheatList[i].value);
+              gbWriteMemory(0xff70, oldbank);
+              gbNextCheat = i+1;
+              return;
+          }
+        }
+        else // These codes are only executed when the game is booted
+        {
+          switch(gbCheatList[i].code & 0xF0) {
+            case 0x80:
+              gbWriteMemory(0x0000, 0x0A);
+              gbWriteMemory(0x4000, gbCheatList[i].value & 0xF);
+              gbWriteMemory(address, gbCheatList[i].value);
+              gbNextCheat = i+1;
+              return;
+          }
+        }
+      }
+    }
+  }
+}
\ No newline at end of file
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbCheats.h ./src/gb/gbCheats.h
--- ../VisualBoyAdvance-1.7.2/src/gb/gbCheats.h	2004-05-13 23:10:49 +0900
+++ ./src/gb/gbCheats.h	2006-06-06 23:25:43 +0900
@@ -50,6 +50,7 @@
 extern void gbCheatEnable(int);
 extern void gbCheatDisable(int);
 extern u8 gbCheatRead(u16);
+extern void gbCheatWrite(bool);
 
 extern int gbCheatNumber;
 extern gbCheat gbCheatList[100];
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbCodes.h ./src/gb/gbCodes.h
--- ../VisualBoyAdvance-1.7.2/src/gb/gbCodes.h	2004-05-13 23:10:32 +0900
+++ ./src/gb/gbCodes.h	2006-04-30 23:41:32 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -22,8 +22,8 @@
    break;
  case 0x01: 
    // LD BC, NNNN
-   BC.B.B0=gbReadMemory(PC.W++);
-   BC.B.B1=gbReadMemory(PC.W++);
+   BC.B.B0=gbReadOpcode(PC.W++);
+   BC.B.B1=gbReadOpcode(PC.W++);
    break;
  case 0x02:
    // LD (BC),A
@@ -102,7 +102,9 @@
    opcode = gbReadOpcode(PC.W++);
    if(gbCgbMode) {
      if(gbMemory[0xff4d] & 1) {
+         
        gbSpeedSwitch();
+       //clockTicks += 228*144-(gbSpeed ? 62 : 63);
        
        if(gbSpeed == 0)
          gbMemory[0xff4d] = 0x00;
@@ -113,8 +115,8 @@
    break;
  case 0x11:
    // LD DE, NNNN
-   DE.B.B0=gbReadMemory(PC.W++);
-   DE.B.B1=gbReadMemory(PC.W++);
+   DE.B.B0=gbReadOpcode(PC.W++);
+   DE.B.B1=gbReadOpcode(PC.W++);
    break;
  case 0x12:
    // LD (DE),A
@@ -147,7 +149,7 @@
    break;
  case 0x18:
    // JR NN
-   PC.W+=(s8)gbReadMemory(PC.W)+1;
+   PC.W+=(s8)gbReadOpcode(PC.W)+1;
    break;
  case 0x19:
    // ADD HL,DE
@@ -190,14 +192,14 @@
    if(AF.B.B0&Z_FLAG)
      PC.W++;
    else {
-     PC.W+=(s8)gbReadMemory(PC.W)+1;
+     PC.W+=(s8)gbReadOpcode(PC.W)+1;
      clockTicks++;
    }
    break;
  case 0x21:
    // LD HL,NNNN
-   HL.B.B0=gbReadMemory(PC.W++);
-   HL.B.B1=gbReadMemory(PC.W++);
+   HL.B.B0=gbReadOpcode(PC.W++);
+   HL.B.B1=gbReadOpcode(PC.W++);
    break;   
  case 0x22:
    // LDI (HL),A
@@ -233,7 +235,7 @@
  case 0x28:
    // JR Z,NN
    if(AF.B.B0&Z_FLAG) {
-     PC.W+=(s8)gbReadMemory(PC.W)+1;
+     PC.W+=(s8)gbReadOpcode(PC.W)+1;
      clockTicks++;
    } else
      PC.W++;
@@ -278,14 +280,14 @@
    if(AF.B.B0&C_FLAG)
      PC.W++;
    else {
-     PC.W+=(s8)gbReadMemory(PC.W)+1;
+     PC.W+=(s8)gbReadOpcode(PC.W)+1;
      clockTicks++;
    }
    break;
  case 0x31:
    // LD SP,NNNN
-   SP.B.B0=gbReadMemory(PC.W++);
-   SP.B.B1=gbReadMemory(PC.W++);
+   SP.B.B0=gbReadOpcode(PC.W++);
+   SP.B.B1=gbReadOpcode(PC.W++);
    break;
  case 0x32:
    // LDD (HL),A
@@ -318,7 +320,7 @@
 case 0x38:
   // JR C,NN
   if(AF.B.B0&C_FLAG) {
-    PC.W+=(s8)gbReadMemory(PC.W)+1;
+    PC.W+=(s8)gbReadOpcode(PC.W)+1;
     clockTicks ++;
   } else
     PC.W++;
@@ -575,16 +577,24 @@
    break;
  case 0x76:
    // HALT
-   if(IFF & 1) {
+   // If an EI is pending, the interrupts are triggered before Halt state !!
+   // Fix Torpedo Range's intro.
+   if (IFF & 0x40)
+   {
+     IFF &= ~0x70;
+     IFF |=1;
      PC.W--;
-     IFF |= 0x80;
-   } else {
-     if((register_IE & register_IF) > 0)
-       IFF |= 0x100;
-     else {
-       PC.W--;
-       IFF |= 0x81;
+   }
+   else
+   {
+     // if (IE & IF) and interrupts are disabeld, 
+     // Halt is cancelled.
+     if ((register_IE & register_IF & 0x1f) && !(IFF & 1))
+     {
+       IFF|=2;
      }
+     else
+       IFF |= 0x80;
    }
    break;
  case 0x77:
@@ -1036,16 +1046,16 @@
    if(AF.B.B0&Z_FLAG)
      PC.W+=2;
    else {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W);
      PC.W=tempRegister.W;
      clockTicks++;
    }
    break;
  case 0xc3:
    // JP NNNN
-   tempRegister.B.B0=gbReadMemory(PC.W++);
-   tempRegister.B.B1=gbReadMemory(PC.W);
+   tempRegister.B.B0=gbReadOpcode(PC.W++);
+   tempRegister.B.B1=gbReadOpcode(PC.W);
    PC.W=tempRegister.W;
    break;
  case 0xc4:
@@ -1053,8 +1063,8 @@
    if(AF.B.B0&Z_FLAG)
      PC.W+=2;
    else {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W++);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W++);
      gbWriteMemory(--SP.W,PC.B.B1);
      gbWriteMemory(--SP.W,PC.B.B0);
      PC.W=tempRegister.W;
@@ -1096,8 +1106,8 @@
  case 0xca:
    // JP Z,NNNN
    if(AF.B.B0&Z_FLAG) {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W);
      PC.W=tempRegister.W;
      clockTicks++;
    } else
@@ -1107,8 +1117,8 @@
  case 0xcc:
    // CALL Z,NNNN
    if(AF.B.B0&Z_FLAG) {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W++);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W++);
      gbWriteMemory(--SP.W,PC.B.B1);
      gbWriteMemory(--SP.W,PC.B.B0);
      PC.W=tempRegister.W;
@@ -1118,8 +1128,8 @@
    break;
  case 0xcd:
    // CALL NNNN
-   tempRegister.B.B0=gbReadMemory(PC.W++);
-   tempRegister.B.B1=gbReadMemory(PC.W++);
+   tempRegister.B.B0=gbReadOpcode(PC.W++);
+   tempRegister.B.B1=gbReadOpcode(PC.W++);
    gbWriteMemory(--SP.W,PC.B.B1);
    gbWriteMemory(--SP.W,PC.B.B0);
    PC.W=tempRegister.W;
@@ -1156,20 +1166,24 @@
    if(AF.B.B0&C_FLAG)
      PC.W+=2;
    else {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W);
      PC.W=tempRegister.W;
      clockTicks++;
    }
    break;
    // D3 illegal
+ case 0xd3:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xd4:
    // CALL NC,NNNN
    if(AF.B.B0&C_FLAG)
      PC.W+=2;
    else {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W++);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W++);
      gbWriteMemory(--SP.W,PC.B.B1);
      gbWriteMemory(--SP.W,PC.B.B0);
      PC.W=tempRegister.W;
@@ -1200,7 +1214,7 @@
    if(AF.B.B0&C_FLAG) {
      PC.B.B0=gbReadMemory(SP.W++);
      PC.B.B1=gbReadMemory(SP.W++);
-     clockTicks += 4;
+     clockTicks += 3;
    }
    break;
  case 0xd9:
@@ -1212,19 +1226,23 @@
  case 0xda:
    // JP C,NNNN
    if(AF.B.B0&C_FLAG) {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W);
      PC.W=tempRegister.W;
      clockTicks++;
    } else
      PC.W+=2;
    break;
    // DB illegal
+ case 0xdb:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xdc:
    // CALL C,NNNN
    if(AF.B.B0&C_FLAG) {
-     tempRegister.B.B0=gbReadMemory(PC.W++);
-     tempRegister.B.B1=gbReadMemory(PC.W++);
+     tempRegister.B.B0=gbReadOpcode(PC.W++);
+     tempRegister.B.B1=gbReadOpcode(PC.W++);
      gbWriteMemory(--SP.W,PC.B.B1);
      gbWriteMemory(--SP.W,PC.B.B0);
      PC.W=tempRegister.W;
@@ -1233,6 +1251,10 @@
      PC.W+=2;
    break;
    // DD illegal
+ case 0xdd:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xde:
    // SBC NN
    tempValue=gbReadOpcode(PC.W++);
@@ -1262,6 +1284,11 @@
    break;
    // E3 illegal
    // E4 illegal
+ case 0xe3:
+ case 0xe4:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xe5:
    // PUSH HL
    gbWriteMemory(--SP.W,HL.B.B1);
@@ -1308,6 +1335,12 @@
    // EB illegal
    // EC illegal
    // ED illegal
+ case 0xeb:
+ case 0xec:
+ case 0xed:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xee:
    // XOR NN
    tempValue=gbReadOpcode(PC.W++);
@@ -1336,9 +1369,13 @@
  case 0xf3:
    // DI
  //   IFF&=0xFE;
-   IFF&=(~0x21);
+     IFF|=0x08;
    break;
    // F4 illegal
+ case 0xf4:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xf5:
    // PUSH AF
    gbWriteMemory(--SP.W,AF.B.B1);
@@ -1383,10 +1420,23 @@
    break;
  case 0xfb:
    // EI
-   IFF|=0x20;
-   break;
-   // FC illegal
+   if (!(IFF & 0x30))
+     // If an EI is executed right before HALT,
+     // the interrupts are triggered before the Halt state !!
+     // Fix Torpedo Range Intro.
+     // IFF |= 0x10 : 1 ticks before the EI enables the interrupts
+     // IFF |= 0x40 : marks that an EI is being executed.
+     IFF|=0x50;
+   break;
+   // FC illegal (FC = breakpoint)
+ case 0xfc:
+    breakpoint = true;
+  break;
    // FD illegal
+ case 0xfd:
+     PC.W--;
+     IFF = 0;
+   break;
  case 0xfe:
    // CP NN
    tempValue=gbReadOpcode(PC.W++);
@@ -1401,7 +1451,10 @@
    PC.W=0x0038;
    break;
  default:
-   systemMessage(0, N_("Unknown opcode %02x at %04x"),
-                 gbReadOpcode(PC.W-1),PC.W-1);
-   emulating = false;
+   if (gbSystemMessage == false)
+   {
+     systemMessage(0, N_("Unknown opcode %02x at %04x"),
+                   gbReadOpcode(PC.W-1),PC.W-1);
+     gbSystemMessage =true;
+   }
    return;
diff -urN ../VisualBoyAdvance-1.7.2/src/gb/gbCodesCB.h ./src/gb/gbCodesCB.h
--- ../VisualBoyAdvance-1.7.2/src/gb/gbCodesCB.h	2004-05-13 23:10:17 +0900
+++ ./src/gb/gbCodesCB.h	2006-01-04 22:38:47 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -1282,7 +1282,10 @@
    AF.B.B1|=1<<7;
    break;
  default:
-   systemMessage(0, N_("Unknown opcode %02x at %04x"),
-                 gbReadOpcode(PC.W-1),PC.W-1);
-   emulating = false;
+   if (gbSystemMessage == false)
+   {
+     systemMessage(0, N_("Unknown opcode %02x at %04x"),
+                   gbReadOpcode(PC.W-1),PC.W-1);
+     gbSystemMessage =true;
+   }
    return;
